
//+------------------------------------------------------------------+
//|                                               Daily High Low.mq4 |
//|                                           Copywrong 2005, RonT   |
//|                                 http://www.lightpatch.com/forex/ |
//|                                 Modified by BlueRain for Reversal|
//+------------------------------------------------------------------+
#property copyright "RonT"
#property link      "http://www.lightpatch.com/forex/"

#property indicator_chart_window
#property indicator_buffers 6


double LOBuffer[];
double HIBuffer[];
double LOArrowBuffer[];
double HIArrowBuffer[];
double LowestArrowBuffer[];
double HighestArrowBuffer[];


extern bool ShowHLLines = false;
extern bool ShowAllHLArrows         = false;
extern int  BarShift = 1;

extern bool   AlertOn             = true;
extern bool   alertsMessage          = true;
extern bool   alertsSound            = false;
extern bool   alertsEmail            = false;



int barshift = 1;
string alert = EMPTY_VALUE;
 
static datetime previousAlertTime,previousPrintTime;
static string   previousAlertMessage;
static string   previousAlertEmailMessage;
static string	 MailSubject = "HL Reversal Alert";

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   if (ShowHLLines)
   {
   SetIndexStyle(0,DRAW_LINE,0,1,Blue);
   SetIndexBuffer(0,LOBuffer);

   SetIndexStyle(1,DRAW_LINE,0,1,Crimson);
   SetIndexBuffer(1,HIBuffer);
  }
  

  if (ShowAllHLArrows )
  {
      SetIndexStyle(2,DRAW_ARROW,EMPTY,1,Blue);
      SetIndexBuffer(2,LOArrowBuffer);
   
   
      SetIndexStyle(3,DRAW_ARROW,EMPTY,1,Crimson);
      SetIndexBuffer(3,HIArrowBuffer);
      
      SetIndexArrow(2, 233);
      SetIndexArrow(3, 234);
      
   }
   
   
   SetIndexStyle(4,DRAW_ARROW,EMPTY,1,Blue);
   SetIndexBuffer(4,LowestArrowBuffer);


   SetIndexStyle(5,DRAW_ARROW,EMPTY,1,Crimson);
   SetIndexBuffer(5,HighestArrowBuffer);
   
   

   SetIndexArrow(4, 233);
   SetIndexArrow(5, 234);
    
    IndicatorShortName(WindowExpertName()); 
    
    //this is needed to make sure alert is happening on time frame only    
    previousAlertTime = Time[0];
    previousAlertMessage = "Init Alert Msg";
    previousAlertEmailMessage = "Init Alert Email Msg";
    

   return(0);
  }



//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int    counted_bars=IndicatorCounted();
   
   int    limit, i,cHighIndex,pHighIndex,cLowIndex,pLowIndex;
 
   double dayhigh=0;
   double daylow=999;
   
   if(counted_bars<0) return(-1);
   limit=(Bars-counted_bars)-1;
 
 //need to redo today's bars if bar count is small
   int MinBarCount = 0;
   
   if (Period() <= PERIOD_H1) 
      MinBarCount = iBarShift(_Symbol,0,iTime(_Symbol,PERIOD_D1,0)) ;
   if (Period() == PERIOD_H4) 
      MinBarCount = iBarShift(_Symbol,0,iTime(_Symbol,PERIOD_W1,0)) ;
   if (Period() >= PERIOD_D1) 
      MinBarCount = iBarShift(_Symbol,0,iTime(_Symbol,PERIOD_MN1,0)) ;
      

   if ( limit < MinBarCount - 1 )
   {
    
      limit = MinBarCount - 1 ;
 
        
   }
 
   cHighIndex = pHighIndex = limit;
   cLowIndex = pLowIndex = limit;
   
   //clean buffer
    for (i=limit; i>= BarShift;i--)
    { 
      HighestArrowBuffer[i] = EMPTY_VALUE;
      LowestArrowBuffer[i] = EMPTY_VALUE;
    }  
   
  //get all HL   
 for (i=limit; i>= BarShift;i--)
 { 
      
         double atr=iATR(NULL,0,100,i); 
      
        
         if (dayhigh<High[i]) {dayhigh=High[i];}
         if (daylow>Low[i])   {daylow=Low[i];  }
       
       
          //higest
          if  ( ( High[i] == dayhigh ) && (Open[i] > Close[i]))
          {
             HighestArrowBuffer[i] = dayhigh + atr/2;
             cHighIndex = i;
         
        
          
             //clear old one
             if (pHighIndex > cHighIndex)
             {
                HighestArrowBuffer[pHighIndex] = EMPTY_VALUE;
              
                pHighIndex = cHighIndex;
             }
          
          }
          
          //lowest
          if  (( Low[i] == daylow ) && (Open[i] < Close[i]))
            {
               LowestArrowBuffer[i] = daylow - atr/2;
               cLowIndex = i;
           
         
                     
                if (pLowIndex > cLowIndex)
                {
                  LowestArrowBuffer[pLowIndex] = EMPTY_VALUE;
                  //move previous pointer to current index
                  pLowIndex = cLowIndex;
              
                  
                }
              }
    
        if ( ( (Period() <= PERIOD_H1) && (TimeDay(Time[i])!=TimeDay(Time[i+1])) ) ||
             ( (Period() == PERIOD_H4) && IsNewWeek(i)    ) ||
             ( (Period() == PERIOD_D1) && IsNewMonth(i)   )
          )
         { 
                           // reset limits when day changes
                           dayhigh=High[i];
                           daylow=Low[i];
                           
                            //reset indexes
                            pLowIndex = cLowIndex = i;
                            pHighIndex = cHighIndex = i;
                
                        
                }
        
           
             LOBuffer[i]=daylow;
             HIBuffer[i]=dayhigh;
  
  
             if  ( ( High[i] == dayhigh ) && (Open[i] > Close[i]))
             {
                    HIArrowBuffer[i] = dayhigh + atr/2;
                                            
             }
             else
             {
                     HIArrowBuffer[i] = EMPTY_VALUE;
              }
      
                    
           //low reversal?
           if  (( Low[i] == daylow ) && (Open[i] < Close[i]))
            {
              LOArrowBuffer[i] = Low[i] - atr/2;
            }
            else
            {
              LOArrowBuffer[i] = EMPTY_VALUE;
            }
            
  
    
   }
 
 
  //alert handling
  if ( (AlertOn == true) && (Time[0]>previousAlertTime) )
  { 
  
  
     	previousAlertTime=Time[0];
     	alert = "";
     	
     	//HI alert
     	if (HighestArrowBuffer[barshift] != EMPTY_VALUE ) 
      {
                
         alert = Symbol() + ", " + TF2Str(Period()) + "  HLReversal Signal DOWN Alert " + " @ " +  TimeToStr(Time[0]);
       
         if (   alertsMessage  )  simpleAlert(alert);
         if (   alertsSound    )  PlaySound("alert2.wav");
         if (   alertsEmail    )   simpleEmail(alert);
         
      }
      else //low?
      if (LowestArrowBuffer[barshift] != EMPTY_VALUE ) 
      {
         
                  
         alert = Symbol() + ", " + TF2Str(Period()) + "  HLReversal Signal UP Alert " + " @ " +  TimeToStr(Time[0]);
       
         if (   alertsMessage  )  simpleAlert(alert);
         if (   alertsSound    )  PlaySound("alert2.wav");
         if (   alertsEmail    )   simpleEmail(alert);
      }
   
    
  
   }
  	
  	
 
     
     
     
     
   return(0);
  }



bool IsNewWeek(int index)
{

  if ( TimeDayOfWeek(Time[index]) == 0)
  return true;
  
  return false;
    
  
}

bool IsNewMonth(int index)
{

   if (TimeDay(Time[index]) == 1 )
   return true;
   
   return false;
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string TF2Str(int nperiod)
 {
   switch(nperiod)
     {
      case PERIOD_M1: return("M1");
      case PERIOD_M5: return("M5");
      case PERIOD_M15: return("M15");
      case PERIOD_M30: return("M30");
      case PERIOD_H1: return("H1");
      case PERIOD_H4: return("H4");
      case PERIOD_D1: return("D1");
      case PERIOD_W1: return("W1");
      case PERIOD_MN1: return("MN");
     }
   return(Period());
  }
//+------------------------------------------------------------------+

  
void simpleAlert(string doWhat)
{
  
   if (previousAlertTime != Time[0] || doWhat != previousAlertMessage)
   {
      previousAlertTime    = Time[0];
      previousAlertMessage =  doWhat;
      Alert(doWhat);
    //  SaveAlertToDisk(doWhat);
      
   }
}

void simpleEmail(string doWhat)
{
     
   if (previousAlertTime != Time[0] || doWhat != previousAlertEmailMessage)
   {
      previousAlertTime    = Time[0];
      previousAlertEmailMessage =  doWhat;
     
      SendMail(MailSubject,doWhat);
   }
}